.module Events
.using Parent

Handler

	cp VMusic2.Events.Directory.Listing
	jr z,Directory.UpdateListing

	cp VMusic2.Events.Disk.FreeSpace
	jr z,Disk.FreeSpace

	cp VMusic2.Events.Directory.Change
	jr z,Directory.Change
	
	cp VMusic2.Events.Music.ReadRegister
	jr z,Music.ReadRegister
	
	cp VMusic2.Events.Music.Stop
	jp z,Music.Stop

	ret

EventTable
.db VMusic2.Events.Directory.Listing \ .dw Directory.UpdateListing
.db VMusic2.Events.Disk.FreeSpace    \ .dw Disk.FreeSpace
.db $FF

.module Directory
	.using Parent.Parent
	; Update the current directory listing info.
	UpdateListing
		call Parent.SkipIfNotData
		
		; Check for empty names:
		ld a,(hl)
		or a
		ret z
		
		call VMusic2.Directory.GetIsDirectory
		jr nz,AddFileName
		
		; Adding a directory is slightly trickier.
		push hl		
		call VMusic2.Directory.GetNameOnly
		
		ld a,(hl)
		cp '.'
		jr nz,{+}
		inc hl
		ld a,(hl)
		dec hl
		or a
		jr nz,{+}
		pop hl
		ret
	+
		
		ld hl,GUI.AvailableDirs
		inc (hl)				
		pop hl
		ld de,(GUI.DownloadedDirNames)
	-	ld a,(hl)
		ld (de),a
		inc hl
		dec de
		or a
		jr nz,{-}		
		ld (GUI.DownloadedDirNames),de
		ret
		
	AddFileName
		push hl
		ld hl,GUI.AvailableFiles
		inc (hl)
		pop hl
		ld de,(GUI.DownloadedFileNames)		
-		ld a,(hl)
		ld (de),a
		inc hl
		inc de
		or a
		jr nz,{-}		
		ld (GUI.DownloadedFileNames),de
		ret
	
	; Change of directory.
	Change
		ld a,d
		cp 1 ; D:\> (ie, changed successfully).
		ret nz
		
		xor a
		ld (VMusic2.LastEvent),a
		jp GUI.RefreshFileList
	
.endmodule


.module Disk
	.using Parent.Parent
	FreeSpace
		call Parent.SkipIfNotData
		ld c,(hl) \ inc hl
		ld b,(hl) \ inc hl
		ld e,(hl) \ inc hl
		ld d,(hl)
		ld h,b \ ld l,c
		; dehl = free space :)
		call VMusic2.Utility.FormatSizeOP1
		ld hl,OP1
		bcall(_PutS)
		bcall(_newline)		
		ret
		
.endmodule


.module Music
	.using Parent.Parent
	ReadRegister
		call Parent.SkipIfNotData
		ld e,(hl) \ inc hl
		ld d,(hl)
		; de = value
		ld a,(VMusic2.Music.LastRegister)
		cp VMusic2.Music.Registers.Vol
		ret nz
		ld (Volume),de
		ld a,1 \ ld (CurrentMode),a ; Jump into the volume control :)
		ret


	Stop
		ld hl,QueuedPlay
		rst rMOV9TOOP1
		call VMusic2.Music.Play
		ret
		
.endmodule

.module General
	.using Parent.Parent
	CheckSuccess
		ret
.endmodule



SkipIfNotData
	ld a,d
	or a
	ret z
	pop af
	ret


.endmodule
VMusic2EventHandler = Events.Handler