.module Program

.var uword, Volume
.var uword, BassTreble
.var ubyte, CurrentMode
.var ubyte[9], QueuedPlay

; ---------------------------------------------------------
; Main -> Program entry point.
; ---------------------------------------------------------
Main

	set appAutoScroll,(iy+appFlags)
	xor a
	ld (curRow),a
	ld (curCol),a
	ld (CurrentMode),a
	
	call VMusic2.Initialise	
	
	call GUI.Reset
	
	ld hl,saveSScreen
	ld bc,768
	bcall(_MemClear)
	

AppLoop

	ld a,(CurrentMode)
	cp 1
	jp z,VolumeControl

-	bcall(_GetCSC)
	
	cp skClear
	ret z
	
	push af
	ld hl,GUI.DirOffset
	ld a,(GUI.SelectedCol)
	or a
	jr z,{+}
	ld hl,GUI.FileOffset
+	pop af
	
	cp skUp
	jr nz,{+}
	dec (hl)
+	cp skDown
	jr nz,{+}
	inc (hl)
+
	cp skLeft
	jr nz,{+}
	push af
	xor a
	ld (GUI.SelectedCol),a
	pop af
+	cp skRight
	jr nz,{+}
	push af
	ld a,1
	ld (GUI.SelectedCol),a
	pop af
+

	cp skAdd
	jp z,VolumeAdjust
	cp skSub
	jp z,VolumeAdjust
	
	cp skGraph
	jr nz,{+}
	push af
	call GUI.RefreshFileList
	pop af
+

	cp sk2nd
	jr z,ClickOnFile

	call VMusic2.Update
	call GUI.Draw
	call ionFastCopy
	jr {-}


GetDirListing
	call VMusic2.Directory.GetListing
	jr AppLoop

GetFreeSpace
	call VMusic2.Disk.GetFreeSpace
	jr AppLoop
	
ClickOnFile
	call GUI.GetSelectedName
	ld a,(GUI.SelectedCol)
	or a
	jr nz,{+}
	; Clicking on a directory.
	call VMusic2.Directory.Change
	jp AppLoop
+	; Clicking on a file.
	ld hl,OP1
	ld de,QueuedPlay
	ld bc,9
	ldir
	call VMusic2.Music.Stop
	jp AppLoop


VolumeControl

	; Draw borders (these do not need to be redrawn!)
	ld hl,plotSScreen+12*17+2
	ld b,8
	call DrawAlignedHorizLine
	
	ld hl,plotSScreen+12*47+2
	ld b,9
	call DrawAlignedHorizLine
	ld hl,plotSScreen+12*48+2
	ld b,9
	call DrawAlignedHorizLine
	
	; Left and right:
	ld bc,%10000000+256*29
	ld hl,plotSScreen+18*12+1
	call DrawVertical
	
	ld b,29
	ld hl,plotSScreen+19*12+11
	call DrawVertical

	ld b,29
	rlc c
	ld hl,plotSScreen+18*12+10
	call DrawVertical
	
	; Fill in gaps :)
	ld c,%01111111
	
	ld hl,plotSScreen+17*12+1
	ld a,(hl) \ or c \ ld (hl),a
	ld hl,plotSScreen+47*12+1
	ld a,(hl) \ or c \ ld (hl),a

	rlc c	
	ld hl,plotSScreen+17*12+10
	ld a,(hl) \ or c \ ld (hl),a
	
	rrc c
	srl c
	ld hl,plotSScreen+48*12+1
	ld a,(hl) \ or c \ ld (hl),a	

VolumeRepaint
	; Clear the main form:
	ld hl,9+18*256
	ld de,86+46*256
	call Dialogs.ClearRect
	
	; Draw the volume speaker icon:
	ld ix,Resources.Images.VolumeSpeaker
	ld a,11
	ld l,20
	ld b,9
	ld c,2
	call ionLargeSprite
	
	; Draw the volume slider bars:
	ld hl,21+20*256
	ld de,84+23*256
	call Dialogs.FillRect
	ld hl,21+(20+5)*256
	ld de,84+(23+5)*256
	call Dialogs.FillRect
	
	; Draw the volume slider contents;
	ld a,(Volume+0)
	ld h,21
	call DrawVolumeSlider
	ld a,(Volume+1)
	ld h,26
	call DrawVolumeSlider
	
	; Draw the text captions:
	set textWrite,(iy+sGrFlags)
	
	ld hl,11+33*256 \ ld (penCol),hl
	ld hl,Resources.Strings.Bass
	bcall(_VPutS)
	
	ld hl,11+39*256 \ ld (penCol),hl
	ld hl,Resources.Strings.Treble
	bcall(_VPutS)
	
	ld hl,51+33*256 \ ld (penCol),hl
	ld hl,Resources.Strings.dB
	bcall(_VPutS)
	
	ld hl,51+39*256 \ ld (penCol),hl
	ld hl,Resources.Strings.dB
	bcall(_VPutS)


	ld hl,77+33*256 \ ld (penCol),hl
	ld hl,Resources.Strings.Hz
	bcall(_VPutS)
	
	ld hl,73+39*256 \ ld (penCol),hl
	ld hl,Resources.Strings.kHz
	bcall(_VPutS)
	


	res textWrite,(iy+sGrFlags)
	
	call ionFastCopy	

VolKeyLoop


	call VMusic2.Update

	; Handle +/- for main volume control.
	ld a,$FF
	nop \ nop
	out (1),a
	ld a,$FD
	nop \ nop
	out (1),a
	nop \ nop
	in a,(1)
	
	ld hl,(Volume)	
	bit 1,a
	jr nz,{+}
	push af
	ld a,h \ call DecreaseA \ ld h,a
	ld a,l \ call DecreaseA \ ld l,a
	pop af
+	bit 2,a
	jr nz,{+}
	push af
	ld a,h \ call IncreaseA \ ld h,a
	ld a,l \ call IncreaseA \ ld l,a
	pop af
+	and %00000110
	cp  %00000110
	jr z,{+}
	; We have changed the volume.
	push hl
	ld a,VMusic2.Music.Registers.Vol
	call VMusic2.Music.WriteRegister
	pop hl
	jr nz,{+}
	ld (Volume),hl
+

	bcall(_GetCSC)
	halt
	or a
	jp z,VolumeControl

	cp skClear
	jr nz,{+}
	xor a
	ld (CurrentMode),a
	jp AppLoop
+
	jp VolumeControl

IncreaseA
	add a,6
	ret p
	ld a,$7F
	ret

DecreaseA
	sub 6
	ret nc
	xor a
	ret

;;;;;;
DrawAlignedHorizLine
-	ld (hl),$FF
	inc hl
	djnz {-}
	ret
;;;;;;;
DrawVertical
	ld de,12
-	ld a,(hl)
	or c
	ld (hl),a
	add hl,de
	djnz {-}
	ret
;;;;;;;
DrawVolumeSlider
	res 7,a
	srl a
	ret z
	neg
	add a,84
	cp 22
	jp p,{+}
	ld a,22
+
	ld l,a

	ld d,h
	inc d
	ld e,83

	call Dialogs.ClearRect
	ret

VolumeAdjust
	ld a,VMusic2.Music.Registers.Vol
	call VMusic2.Music.ReadRegister
	jp AppLoop

.include "Events.asm"
.include "VMusic2/VMusic2.asm"
.include "Resources/Resources.inc"

.include "GUI.asm"
.include "Dialogs.asm"
.include "FixedWidth.asm"
.endmodule